//+------------------------------------------------------------------+
//|                                                  LSMA-v1.1.mq4   |
//|                      Copyright  2006 Sunwest3d                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "EA LSMA by Sunwest3D Copyright  2006"

extern int Flsma = 12;
extern int Slsma = 65;
extern double TakeProfit = 500;
extern double ProfitModifySL=0;
extern double StopLoss= 500;

extern double TrailingStop=0;
extern double Slippage = 3;
extern double Lots=0.1;

extern bool AlertCross= false;

double dFlsma,dSlsma;
double Fsum,Ssum;
double Fwt,Swt,pFwt,pSwt;
int   BarInProgress;
bool  CalDoneEA;

color clOpenBuy = Blue;
color clOpenSell = Red;
color clCloseBuy = Aqua;
color clCloseSell = Violet;
color clModiBuy = Blue;
color clModiSell = Red;

int   Position;
int   Magic;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   CalDoneEA=true;
   Position=0;
   Magic = Period()+777;
   return(0);
  }
  
  
//+------------------------------------------------------------------+
//|     Start of the EA Sample                                       |
//+------------------------------------------------------------------+
int start()
  {
   if (Volume[0]==1 && CalDoneEA==false)   // First tick of the new hour
      { 
         pSwt=Swt; pFwt=Fwt;
         Swt=  iCustom(Symbol(),0,"LSMA-V1.2",Flsma,Slsma,false,false,0,1);
         Fwt=  iCustom(Symbol(),0,"LSMA-V1.2",Flsma,Slsma,false,false,1,1);

         CalDoneEA=true;
   
         if (Fwt<Swt && pFwt>pSwt && Position==1)   {fCloseOpenOrders();}//fSell();Position=2;}
         else if (Fwt>Swt && pFwt<pSwt && Position==2)   {fCloseOpenOrders();}//fBuy();Position=1;}
         
         if (OrdersTotal()==0)
         {
            if (Fwt>Swt && pFwt<pSwt)   {fBuy();Position=1;}
            else if (Fwt<Swt && pFwt>pSwt)   {fSell();Position=2;}
         }
         
      }
   else if (Volume[0]>1) CalDoneEA=false;
   
   if (OrdersTotal()>0)
      {          
         if (ProfitModifySL>0)   fModifySLWhenInProfit();
         if (TrailingStop>0)     fTrailStop();
      }   

   
   
   return(0);
  }
// ***** End of Main Loop ******



//+------------------------------------------------------------------+
//| Buy                                                              |
//+------------------------------------------------------------------+
void fBuy()
{
   int ticket =OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,NULL,Magic,0,clOpenBuy); 
   if(ticket>0)
   {
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
   }
   else Print("Error opening BUY order : ",GetLastError());
   
}
//+------------------------------------------------------------------+
//| Sell                                                             |
//+------------------------------------------------------------------+
void fSell()
{
   int ticket =OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,Bid-TakeProfit*Point,NULL,Magic,0,clOpenSell); 
   if(ticket>0)
   {
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
   }
   else Print("Error opening SELL order : ",GetLastError());
}

//+------------------------------------------------------------------+
//| Scan through Order and if in profit by PrmSL Modify SL           |
//+------------------------------------------------------------------+
void fModifySLWhenInProfit()
{
   for (int i=0; i<OrdersTotal(); i++) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
         {
            if (OrderType()==OP_BUY && Bid-OrderOpenPrice()>=ProfitModifySL*Point)
               if (OrderStopLoss()<OrderOpenPrice())  fModifyStopLoss(OrderOpenPrice());
               
            if (OrderType()==OP_SELL && OrderOpenPrice()-Ask>=ProfitModifySL*Point) 
               if (OrderStopLoss()>OrderOpenPrice())  fModifyStopLoss(OrderOpenPrice());
         } 
      } 
    }
}


//+------------------------------------------------------------------+
//| Modify Stop Loss                                                 |
//+------------------------------------------------------------------+
void fModifyStopLoss(double tStopLoss) 
{ 
   bool result = OrderModify(OrderTicket(),OrderOpenPrice(),tStopLoss,OrderTakeProfit(),0,NULL); 
   
   if (result) Print("StopLoss Modified for ticket ",OrderTicket()," to ",tStopLoss);
   else Print("Could not modify Stop Loss for ticket ",OrderTicket()," to ",tStopLoss);
   
}
//+------------------------------------------------------------------+
//| Trailling Stop Loss                                              |
//+------------------------------------------------------------------+
void fTrailStop()
{
   for (int i=0; i<OrdersTotal(); i++) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
         {
            if (OrderType()==OP_BUY) 
            { 
               if (Bid-OrderOpenPrice()>TrailingStop*Point) 
               { 
                  if (OrderStopLoss()<Bid-TrailingStop*Point) 
                     fModifyStopLoss(Bid-TrailingStop*Point); 
               }
            }
            if (OrderType()==OP_SELL)
            {
               if (OrderOpenPrice()-Ask>TrailingStop*Point) 
               {
                  if (OrderStopLoss()>Ask+TrailingStop*Point || OrderStopLoss()==0)  
                     fModifyStopLoss(Ask+TrailingStop*Point); 
               }
                   
            } 
         } 
      } 
    } 
}

//+------------------------------------------------------------------+
//| Close all running order                                          |
//+------------------------------------------------------------------+
void fCloseOpenOrders()
{
   bool tClosing;
   
   for (int i=0; i<OrdersTotal(); i++) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
         {
            if (OrderType()==OP_BUY)  tClosing = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), Slippage, clCloseBuy );
            if (OrderType()==OP_SELL) tClosing = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), Slippage, clCloseSell );
         } 
      } 
    }
}

